"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.Syntax = Syntax;
const syntax_from_syntax_1 = require("./syntax-from-syntax");
const syntax_from_typebox_1 = require("./syntax-from-typebox");
const syntax_from_valibot_1 = require("./syntax-from-valibot");
const syntax_from_zod_1 = require("./syntax-from-zod");
const g = require("../guard");
const z = require("zod");
/** Creates Syntax by mapping from a remote Type */
// prettier-ignore
function Syntax(...args) {
    const [_parameter, type, _options] = g.Signature(args);
    return (g.IsSyntax(type) ? (0, syntax_from_syntax_1.SyntaxFromSyntax)(type) :
        g.IsTypeBox(type) ? (0, syntax_from_typebox_1.SyntaxFromTypeBox)(type) :
            g.IsValibot(type) ? (0, syntax_from_valibot_1.SyntaxFromValibot)(type) :
                g.IsZod(type) ? (0, syntax_from_zod_1.SyntaxFromZod)(type) :
                    z.never());
}
