"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.Valibot = Valibot;
const valibot_from_syntax_1 = require("./valibot-from-syntax");
const valibot_from_typebox_1 = require("./valibot-from-typebox");
const valibot_from_valibot_1 = require("./valibot-from-valibot");
const valibot_from_zod_1 = require("./valibot-from-zod");
const typebox_1 = require("../typebox/typebox");
const g = require("../guard");
const v = require("valibot");
/** Creates a Valibot type by mapping from a remote Type */
// prettier-ignore
function Valibot(...args) {
    const [parameter, type, options] = g.Signature(args);
    return (g.IsSyntax(type) ? (0, valibot_from_syntax_1.ValibotFromSyntax)((0, typebox_1.ContextFromParameter)(parameter), type, options) :
        g.IsTypeBox(type) ? (0, valibot_from_typebox_1.ValibotFromTypeBox)(type) :
            g.IsValibot(type) ? (0, valibot_from_valibot_1.ValibotFromValibot)(type) :
                g.IsZod(type) ? (0, valibot_from_zod_1.ValibotFromZod)(type) :
                    v.never());
}
