"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.Zod = Zod;
const zod_from_syntax_1 = require("./zod-from-syntax");
const zod_from_typebox_1 = require("./zod-from-typebox");
const zod_from_valibot_1 = require("./zod-from-valibot");
const zod_from_zod_1 = require("./zod-from-zod");
const typebox_1 = require("../typebox/typebox");
const g = require("../guard");
const z = require("zod");
/** Creates a Zod type by mapping from a remote Type */
// prettier-ignore
function Zod(...args) {
    const [parameter, type, options] = g.Signature(args);
    return (g.IsSyntax(type) ? (0, zod_from_syntax_1.ZodFromSyntax)((0, typebox_1.ContextFromParameter)(parameter), type, options) :
        g.IsTypeBox(type) ? (0, zod_from_typebox_1.ZodFromTypeBox)(type) :
            g.IsValibot(type) ? (0, zod_from_valibot_1.ZodFromValibot)(type) :
                g.IsZod(type) ? (0, zod_from_zod_1.ZodFromZod)(type) :
                    z.never());
}
