/**
 * Converts a json pointer path (https://datatracker.ietf.org/doc/html/rfc6901)
 * to a format which is followed by standard-schema and zod
 */
export function ZodPathFromJsonPointer(jsonPointer) {
    if (jsonPointer === '')
        return [];
    if (jsonPointer === '/')
        return [''];
    return jsonPointer
        .substring(1)
        .split('/')
        .map((segment) => segment.replace(/~1/g, '/').replace(/~0/g, '~'))
        .map((segment) => (isNaN(segment) ? segment : parseInt(segment)));
}
