import { type TSyntaxFromSyntax } from './syntax-from-syntax.mjs';
import { type TSyntaxFromTypeBox } from './syntax-from-typebox.mjs';
import { type TSyntaxFromValibot } from './syntax-from-valibot.mjs';
import { type TSyntaxFromZod } from './syntax-from-zod.mjs';
import { type TSyntaxOptions } from '../options.mjs';
import { type TParameter } from '../typebox/typebox.mjs';
import * as g from '../guard.mjs';
/** Creates Syntax by mapping from a remote Type */
export type TSyntax<_Parameter extends TParameter, Type extends object | string, Result extends string = (Type extends g.SyntaxType ? TSyntaxFromSyntax<Type> : Type extends g.TypeBoxType ? TSyntaxFromTypeBox<Type> : Type extends g.ValibotType ? TSyntaxFromValibot<Type> : Type extends g.ZodType ? TSyntaxFromZod<Type> : 'never')> = Result;
/** Creates Syntax by mapping from a remote Type */
export declare function Syntax<Parameter extends TParameter, Type extends string>(parameter: Parameter, type: Type, options?: TSyntaxOptions): TSyntax<Parameter, Type>;
/** Creates Syntax by mapping from a remote Type */
export declare function Syntax<Type extends string>(type: Type, options?: TSyntaxOptions): TSyntax<{}, Type>;
/** Creates Syntax by mapping from a remote Type */
export declare function Syntax<Type extends object>(type: Type, options?: TSyntaxOptions): TSyntax<{}, Type>;
