import { type TTypeBoxFromValibot } from '../typebox/typebox-from-valibot.mjs';
import { type TZodFromTypeBox } from './zod-from-typebox.mjs';
import * as t from '@sinclair/typebox';
import * as v from 'valibot';
import * as z from 'zod';
/** Creates a Zod type from Valibot */
export type TZodFromValibot<Type extends v.BaseSchema<any, any, any>, TypeBox extends t.TSchema = TTypeBoxFromValibot<Type>, Result extends z.ZodTypeAny | z.ZodEffects<any> = TZodFromTypeBox<TypeBox>> = Result;
/** Creates a Zod type from Valibot */
export declare function ZodFromValibot<Type extends v.BaseSchema<any, any, any>>(type: Type): TZodFromValibot<Type>;
