import { type TZodFromSyntax } from './zod-from-syntax.mjs';
import { type TZodFromTypeBox } from './zod-from-typebox.mjs';
import { type TZodFromValibot } from './zod-from-valibot.mjs';
import { type TZodFromZod } from './zod-from-zod.mjs';
import { type TSyntaxOptions } from '../options.mjs';
import { type TParameter, type TContextFromParameter } from '../typebox/typebox.mjs';
import * as g from '../guard.mjs';
import * as z from 'zod';
/** Creates a Zod type by mapping from a remote Type */
export type TZod<Parameter extends TParameter, Type extends object | string, Result extends z.ZodTypeAny | z.ZodEffects<any> = (Type extends g.SyntaxType ? TZodFromSyntax<TContextFromParameter<Parameter>, Type> : Type extends g.TypeBoxType ? TZodFromTypeBox<Type> : Type extends g.ValibotType ? TZodFromValibot<Type> : Type extends g.ZodType ? TZodFromZod<Type> : z.ZodNever)> = Result;
/** Creates a Zod type by mapping from a remote Type */
export declare function Zod<Parameter extends TParameter, Type extends string>(parameter: Parameter, type: Type, options?: TSyntaxOptions): TZod<Parameter, Type>;
/** Creates a Zod type by mapping from a remote Type */
export declare function Zod<Type extends string>(type: Type, options?: TSyntaxOptions): TZod<{}, Type>;
/** Creates a Zod type by mapping from a remote Type */
export declare function Zod<Type extends object>(type: Type, options?: TSyntaxOptions): TZod<{}, Type>;
